// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.
// Autogenerated from Pigeon (v9.2.5), do not edit directly.
// See also: https://pub.dev/packages/pigeon

#import <Foundation/Foundation.h>

@protocol FlutterBinaryMessenger;
@protocol FlutterMessageCodec;
@class FlutterError;
@class FlutterStandardTypedData;

NS_ASSUME_NONNULL_BEGIN

/// 视频水印类型
typedef NS_ENUM(NSUInteger, NEFLTNERtcVideoWatermarkType) {
  /// 图片
  NEFLTNERtcVideoWatermarkTypeKNERtcVideoWatermarkTypeImage = 0,
  /// 文字
  NEFLTNERtcVideoWatermarkTypeKNERtcVideoWatermarkTypeText = 1,
  /// 时间戳
  NEFLTNERtcVideoWatermarkTypeKNERtcVideoWatermarkTypeTimeStamp = 2,
};

/// 摄像头额外旋转信息
typedef NS_ENUM(NSUInteger, NEFLTNERtcCaptureExtraRotation) {
  /// （默认）没有额外的旋转信息，直接使用系统旋转参数处理
  NEFLTNERtcCaptureExtraRotationKNERtcCaptureExtraRotationDefault = 0,
  /// 在系统旋转信息的基础上，额外顺时针旋转90度
  NEFLTNERtcCaptureExtraRotationKNERtcCaptureExtraRotationClockWise90 = 1,
  /// 在系统旋转信息的基础上，额外旋转180度
  NEFLTNERtcCaptureExtraRotationKNERtcCaptureExtraRotation180 = 2,
  /// 在系统旋转信息的基础上，额外逆时针旋转90度
  NEFLTNERtcCaptureExtraRotationKNERtcCaptureExtraRotationAntiClockWise90 = 3,
};

@class NEFLTNERtcUserJoinExtraInfo;
@class NEFLTNERtcUserLeaveExtraInfo;
@class NEFLTUserJoinedEvent;
@class NEFLTUserLeaveEvent;
@class NEFLTUserVideoMuteEvent;
@class NEFLTFirstVideoDataReceivedEvent;
@class NEFLTFirstVideoFrameDecodedEvent;
@class NEFLTVirtualBackgroundSourceEnabledEvent;
@class NEFLTAudioVolumeInfo;
@class NEFLTRemoteAudioVolumeIndicationEvent;
@class NEFLTNERtcLastmileProbeResult;
@class NEFLTNERtcLastmileProbeOneWayResult;
@class NEFLTRtcServerAddresses;
@class NEFLTCreateEngineRequest;
@class NEFLTJoinChannelOptions;
@class NEFLTJoinChannelRequest;
@class NEFLTSubscribeRemoteAudioRequest;
@class NEFLTEnableLocalVideoRequest;
@class NEFLTSetAudioProfileRequest;
@class NEFLTSetLocalVideoConfigRequest;
@class NEFLTSetCameraCaptureConfigRequest;
@class NEFLTStartorStopVideoPreviewRequest;
@class NEFLTStartScreenCaptureRequest;
@class NEFLTSubscribeRemoteVideoStreamRequest;
@class NEFLTSubscribeRemoteSubStreamVideoRequest;
@class NEFLTEnableAudioVolumeIndicationRequest;
@class NEFLTSubscribeRemoteSubStreamAudioRequest;
@class NEFLTSetAudioSubscribeOnlyByRequest;
@class NEFLTStartAudioMixingRequest;
@class NEFLTPlayEffectRequest;
@class NEFLTSetCameraPositionRequest;
@class NEFLTAddOrUpdateLiveStreamTaskRequest;
@class NEFLTDeleteLiveStreamTaskRequest;
@class NEFLTSendSEIMsgRequest;
@class NEFLTSetLocalVoiceEqualizationRequest;
@class NEFLTSwitchChannelRequest;
@class NEFLTStartAudioRecordingRequest;
@class NEFLTAudioRecordingConfigurationRequest;
@class NEFLTSetLocalMediaPriorityRequest;
@class NEFLTStartOrUpdateChannelMediaRelayRequest;
@class NEFLTAdjustUserPlaybackSignalVolumeRequest;
@class NEFLTEnableEncryptionRequest;
@class NEFLTSetLocalVoiceReverbParamRequest;
@class NEFLTReportCustomEventRequest;
@class NEFLTStartLastmileProbeTestRequest;
@class NEFLTCGPoint;
@class NEFLTSetVideoCorrectionConfigRequest;
@class NEFLTEnableVirtualBackgroundRequest;
@class NEFLTSetRemoteHighPriorityAudioStreamRequest;
@class NEFLTVideoWatermarkImageConfig;
@class NEFLTVideoWatermarkTextConfig;
@class NEFLTVideoWatermarkTimestampConfig;
@class NEFLTVideoWatermarkConfig;
@class NEFLTSetLocalVideoWatermarkConfigsRequest;
@class NEFLTNERtcVersion;
@class NEFLTVideoFrame;

/// onUserJoined 回调的一些可选信息
@interface NEFLTNERtcUserJoinExtraInfo : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithCustomInfo:(NSString *)customInfo;
/// 自定义信息， 来源于远端用户joinChannel时填的
/// [NERtcJoinChannelOptions.customInfo]参数，默认为空字符串。
@property(nonatomic, copy) NSString *customInfo;
@end

/// onUserLeave 回调的一些可选信息
@interface NEFLTNERtcUserLeaveExtraInfo : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithCustomInfo:(NSString *)customInfo;
/// 自定义信息, 来源于远端用户joinChannel时填的
/// [NERtcJoinChannelOptions.customInfo]参数，默认为空字符串。
@property(nonatomic, copy) NSString *customInfo;
@end

@interface NEFLTUserJoinedEvent : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithUid:(NSNumber *)uid
              joinExtraInfo:(nullable NEFLTNERtcUserJoinExtraInfo *)joinExtraInfo;
@property(nonatomic, strong) NSNumber *uid;
@property(nonatomic, strong, nullable) NEFLTNERtcUserJoinExtraInfo *joinExtraInfo;
@end

@interface NEFLTUserLeaveEvent : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithUid:(NSNumber *)uid
                     reason:(NSNumber *)reason
             leaveExtraInfo:(nullable NEFLTNERtcUserLeaveExtraInfo *)leaveExtraInfo;
@property(nonatomic, strong) NSNumber *uid;
@property(nonatomic, strong) NSNumber *reason;
@property(nonatomic, strong, nullable) NEFLTNERtcUserLeaveExtraInfo *leaveExtraInfo;
@end

@interface NEFLTUserVideoMuteEvent : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithUid:(NSNumber *)uid
                      muted:(NSNumber *)muted
                 streamType:(nullable NSNumber *)streamType;
@property(nonatomic, strong) NSNumber *uid;
@property(nonatomic, strong) NSNumber *muted;
@property(nonatomic, strong, nullable) NSNumber *streamType;
@end

@interface NEFLTFirstVideoDataReceivedEvent : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithUid:(NSNumber *)uid streamType:(nullable NSNumber *)streamType;
@property(nonatomic, strong) NSNumber *uid;
@property(nonatomic, strong, nullable) NSNumber *streamType;
@end

@interface NEFLTFirstVideoFrameDecodedEvent : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithUid:(NSNumber *)uid
                      width:(NSNumber *)width
                     height:(NSNumber *)height
                 streamType:(nullable NSNumber *)streamType;
@property(nonatomic, strong) NSNumber *uid;
@property(nonatomic, strong) NSNumber *width;
@property(nonatomic, strong) NSNumber *height;
@property(nonatomic, strong, nullable) NSNumber *streamType;
@end

@interface NEFLTVirtualBackgroundSourceEnabledEvent : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithEnabled:(NSNumber *)enabled reason:(NSNumber *)reason;
@property(nonatomic, strong) NSNumber *enabled;
@property(nonatomic, strong) NSNumber *reason;
@end

@interface NEFLTAudioVolumeInfo : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithUid:(NSNumber *)uid
                     volume:(NSNumber *)volume
            subStreamVolume:(NSNumber *)subStreamVolume;
@property(nonatomic, strong) NSNumber *uid;
@property(nonatomic, strong) NSNumber *volume;
@property(nonatomic, strong) NSNumber *subStreamVolume;
@end

@interface NEFLTRemoteAudioVolumeIndicationEvent : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithVolumeList:(nullable NSArray<NEFLTAudioVolumeInfo *> *)volumeList
                       totalVolume:(NSNumber *)totalVolume;
@property(nonatomic, strong, nullable) NSArray<NEFLTAudioVolumeInfo *> *volumeList;
@property(nonatomic, strong) NSNumber *totalVolume;
@end

/// 上下行 Last mile 网络质量探测结果
@interface NEFLTNERtcLastmileProbeResult : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithState:(NSNumber *)state
                          rtt:(NSNumber *)rtt
                 uplinkReport:(NEFLTNERtcLastmileProbeOneWayResult *)uplinkReport
               downlinkReport:(NEFLTNERtcLastmileProbeOneWayResult *)downlinkReport;
/// Last mile 质量探测结果的状态, 详细参数见 [NERtcLastmileProbeResultState]
@property(nonatomic, strong) NSNumber *state;
/// 往返时延，单位为毫秒(ms)
@property(nonatomic, strong) NSNumber *rtt;
/// 上行网络质量报告
@property(nonatomic, strong) NEFLTNERtcLastmileProbeOneWayResult *uplinkReport;
/// 下行网络质量报告
@property(nonatomic, strong) NEFLTNERtcLastmileProbeOneWayResult *downlinkReport;
@end

/// 单向 Last mile 网络质量探测结果报告
@interface NEFLTNERtcLastmileProbeOneWayResult : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithPacketLossRate:(NSNumber *)packetLossRate
                                jitter:(NSNumber *)jitter
                    availableBandwidth:(NSNumber *)availableBandwidth;
/// 丢包率
@property(nonatomic, strong) NSNumber *packetLossRate;
/// 网络抖动，单位为毫秒 (ms)
@property(nonatomic, strong) NSNumber *jitter;
/// 可用网络带宽预估，单位为 bps
@property(nonatomic, strong) NSNumber *availableBandwidth;
@end

@interface NEFLTRtcServerAddresses : NSObject
+ (instancetype)makeWithValid:(nullable NSNumber *)valid
                channelServer:(nullable NSString *)channelServer
             statisticsServer:(nullable NSString *)statisticsServer
                   roomServer:(nullable NSString *)roomServer
                 compatServer:(nullable NSString *)compatServer
                 nosLbsServer:(nullable NSString *)nosLbsServer
               nosUploadSever:(nullable NSString *)nosUploadSever
               nosTokenServer:(nullable NSString *)nosTokenServer
              sdkConfigServer:(nullable NSString *)sdkConfigServer
             cloudProxyServer:(nullable NSString *)cloudProxyServer
         webSocketProxyServer:(nullable NSString *)webSocketProxyServer
              quicProxyServer:(nullable NSString *)quicProxyServer
             mediaProxyServer:(nullable NSString *)mediaProxyServer
     statisticsDispatchServer:(nullable NSString *)statisticsDispatchServer
       statisticsBackupServer:(nullable NSString *)statisticsBackupServer
                      useIPv6:(nullable NSNumber *)useIPv6;
@property(nonatomic, strong, nullable) NSNumber *valid;
@property(nonatomic, copy, nullable) NSString *channelServer;
@property(nonatomic, copy, nullable) NSString *statisticsServer;
@property(nonatomic, copy, nullable) NSString *roomServer;
@property(nonatomic, copy, nullable) NSString *compatServer;
@property(nonatomic, copy, nullable) NSString *nosLbsServer;
@property(nonatomic, copy, nullable) NSString *nosUploadSever;
@property(nonatomic, copy, nullable) NSString *nosTokenServer;
@property(nonatomic, copy, nullable) NSString *sdkConfigServer;
@property(nonatomic, copy, nullable) NSString *cloudProxyServer;
@property(nonatomic, copy, nullable) NSString *webSocketProxyServer;
@property(nonatomic, copy, nullable) NSString *quicProxyServer;
@property(nonatomic, copy, nullable) NSString *mediaProxyServer;
@property(nonatomic, copy, nullable) NSString *statisticsDispatchServer;
@property(nonatomic, copy, nullable) NSString *statisticsBackupServer;
@property(nonatomic, strong, nullable) NSNumber *useIPv6;
@end

@interface NEFLTCreateEngineRequest : NSObject
+ (instancetype)makeWithAppKey:(nullable NSString *)appKey
                                   logDir:(nullable NSString *)logDir
                          serverAddresses:(nullable NEFLTRtcServerAddresses *)serverAddresses
                                 logLevel:(nullable NSNumber *)logLevel
                       audioAutoSubscribe:(nullable NSNumber *)audioAutoSubscribe
                       videoAutoSubscribe:(nullable NSNumber *)videoAutoSubscribe
        disableFirstJoinUserCreateChannel:(nullable NSNumber *)disableFirstJoinUserCreateChannel
    audioDisableOverrideSpeakerOnReceiver:(nullable NSNumber *)audioDisableOverrideSpeakerOnReceiver
               audioDisableSWAECOnHeadset:(nullable NSNumber *)audioDisableSWAECOnHeadset
                         audioAINSEnabled:(nullable NSNumber *)audioAINSEnabled
                        serverRecordAudio:(nullable NSNumber *)serverRecordAudio
                        serverRecordVideo:(nullable NSNumber *)serverRecordVideo
                         serverRecordMode:(nullable NSNumber *)serverRecordMode
                      serverRecordSpeaker:(nullable NSNumber *)serverRecordSpeaker
                        publishSelfStream:(nullable NSNumber *)publishSelfStream
              videoCaptureObserverEnabled:(nullable NSNumber *)videoCaptureObserverEnabled
                          videoEncodeMode:(nullable NSNumber *)videoEncodeMode
                          videoDecodeMode:(nullable NSNumber *)videoDecodeMode
                            videoSendMode:(nullable NSNumber *)videoSendMode
                         videoH265Enabled:(nullable NSNumber *)videoH265Enabled
                           mode1v1Enabled:(nullable NSNumber *)mode1v1Enabled;
@property(nonatomic, copy, nullable) NSString *appKey;
@property(nonatomic, copy, nullable) NSString *logDir;
@property(nonatomic, strong, nullable) NEFLTRtcServerAddresses *serverAddresses;
@property(nonatomic, strong, nullable) NSNumber *logLevel;
@property(nonatomic, strong, nullable) NSNumber *audioAutoSubscribe;
@property(nonatomic, strong, nullable) NSNumber *videoAutoSubscribe;
@property(nonatomic, strong, nullable) NSNumber *disableFirstJoinUserCreateChannel;
@property(nonatomic, strong, nullable) NSNumber *audioDisableOverrideSpeakerOnReceiver;
@property(nonatomic, strong, nullable) NSNumber *audioDisableSWAECOnHeadset;
@property(nonatomic, strong, nullable) NSNumber *audioAINSEnabled;
@property(nonatomic, strong, nullable) NSNumber *serverRecordAudio;
@property(nonatomic, strong, nullable) NSNumber *serverRecordVideo;
@property(nonatomic, strong, nullable) NSNumber *serverRecordMode;
@property(nonatomic, strong, nullable) NSNumber *serverRecordSpeaker;
@property(nonatomic, strong, nullable) NSNumber *publishSelfStream;
@property(nonatomic, strong, nullable) NSNumber *videoCaptureObserverEnabled;
@property(nonatomic, strong, nullable) NSNumber *videoEncodeMode;
@property(nonatomic, strong, nullable) NSNumber *videoDecodeMode;
@property(nonatomic, strong, nullable) NSNumber *videoSendMode;
@property(nonatomic, strong, nullable) NSNumber *videoH265Enabled;
@property(nonatomic, strong, nullable) NSNumber *mode1v1Enabled;
@end

@interface NEFLTJoinChannelOptions : NSObject
+ (instancetype)makeWithCustomInfo:(nullable NSString *)customInfo
                     permissionKey:(nullable NSString *)permissionKey;
@property(nonatomic, copy, nullable) NSString *customInfo;
@property(nonatomic, copy, nullable) NSString *permissionKey;
@end

@interface NEFLTJoinChannelRequest : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithToken:(nullable NSString *)token
                  channelName:(NSString *)channelName
                          uid:(NSNumber *)uid
               channelOptions:(nullable NEFLTJoinChannelOptions *)channelOptions;
@property(nonatomic, copy, nullable) NSString *token;
@property(nonatomic, copy) NSString *channelName;
@property(nonatomic, strong) NSNumber *uid;
@property(nonatomic, strong, nullable) NEFLTJoinChannelOptions *channelOptions;
@end

@interface NEFLTSubscribeRemoteAudioRequest : NSObject
+ (instancetype)makeWithUid:(nullable NSNumber *)uid subscribe:(nullable NSNumber *)subscribe;
@property(nonatomic, strong, nullable) NSNumber *uid;
@property(nonatomic, strong, nullable) NSNumber *subscribe;
@end

@interface NEFLTEnableLocalVideoRequest : NSObject
+ (instancetype)makeWithEnable:(nullable NSNumber *)enable
                    streamType:(nullable NSNumber *)streamType;
@property(nonatomic, strong, nullable) NSNumber *enable;
@property(nonatomic, strong, nullable) NSNumber *streamType;
@end

@interface NEFLTSetAudioProfileRequest : NSObject
+ (instancetype)makeWithProfile:(nullable NSNumber *)profile scenario:(nullable NSNumber *)scenario;
@property(nonatomic, strong, nullable) NSNumber *profile;
@property(nonatomic, strong, nullable) NSNumber *scenario;
@end

@interface NEFLTSetLocalVideoConfigRequest : NSObject
+ (instancetype)makeWithVideoProfile:(nullable NSNumber *)videoProfile
                       videoCropMode:(nullable NSNumber *)videoCropMode
                         frontCamera:(nullable NSNumber *)frontCamera
                           frameRate:(nullable NSNumber *)frameRate
                        minFrameRate:(nullable NSNumber *)minFrameRate
                             bitrate:(nullable NSNumber *)bitrate
                          minBitrate:(nullable NSNumber *)minBitrate
                   degradationPrefer:(nullable NSNumber *)degradationPrefer
                               width:(nullable NSNumber *)width
                              height:(nullable NSNumber *)height
                          cameraType:(nullable NSNumber *)cameraType
                          mirrorMode:(nullable NSNumber *)mirrorMode
                     orientationMode:(nullable NSNumber *)orientationMode
                          streamType:(nullable NSNumber *)streamType;
@property(nonatomic, strong, nullable) NSNumber *videoProfile;
@property(nonatomic, strong, nullable) NSNumber *videoCropMode;
@property(nonatomic, strong, nullable) NSNumber *frontCamera;
@property(nonatomic, strong, nullable) NSNumber *frameRate;
@property(nonatomic, strong, nullable) NSNumber *minFrameRate;
@property(nonatomic, strong, nullable) NSNumber *bitrate;
@property(nonatomic, strong, nullable) NSNumber *minBitrate;
@property(nonatomic, strong, nullable) NSNumber *degradationPrefer;
@property(nonatomic, strong, nullable) NSNumber *width;
@property(nonatomic, strong, nullable) NSNumber *height;
@property(nonatomic, strong, nullable) NSNumber *cameraType;
@property(nonatomic, strong, nullable) NSNumber *mirrorMode;
@property(nonatomic, strong, nullable) NSNumber *orientationMode;
@property(nonatomic, strong, nullable) NSNumber *streamType;
@end

/// 摄像头采集配置
@interface NEFLTSetCameraCaptureConfigRequest : NSObject
+ (instancetype)makeWithExtraRotation:(NEFLTNERtcCaptureExtraRotation)extraRotation
                         captureWidth:(nullable NSNumber *)captureWidth
                        captureHeight:(nullable NSNumber *)captureHeight
                           streamType:(nullable NSNumber *)streamType;
/// 设置摄像头的额外旋转信息
@property(nonatomic, assign) NEFLTNERtcCaptureExtraRotation extraRotation;
/// 本地采集的视频宽度，单位为 px。
///
/// 视频编码分辨率以宽 x 高表示，用于设置视频编码分辨率，以衡量编码质量。
///
/// captureWidth 表示视频帧在横轴上的像素，即自定义宽。
@property(nonatomic, strong, nullable) NSNumber *captureWidth;
/// 本地采集的视频宽度，单位为 px。
///
/// 视频编码分辨率以宽 x 高表示，用于设置视频编码分辨率，以衡量编码质量。
///
/// captureHeight 表示视频帧在横轴上的像素，即自定义高。
@property(nonatomic, strong, nullable) NSNumber *captureHeight;
/// 视频流类型
@property(nonatomic, strong, nullable) NSNumber *streamType;
@end

@interface NEFLTStartorStopVideoPreviewRequest : NSObject
+ (instancetype)makeWithStreamType:(nullable NSNumber *)streamType;
@property(nonatomic, strong, nullable) NSNumber *streamType;
@end

@interface NEFLTStartScreenCaptureRequest : NSObject
+ (instancetype)makeWithContentPrefer:(nullable NSNumber *)contentPrefer
                         videoProfile:(nullable NSNumber *)videoProfile
                            frameRate:(nullable NSNumber *)frameRate
                         minFrameRate:(nullable NSNumber *)minFrameRate
                              bitrate:(nullable NSNumber *)bitrate
                           minBitrate:(nullable NSNumber *)minBitrate;
@property(nonatomic, strong, nullable) NSNumber *contentPrefer;
@property(nonatomic, strong, nullable) NSNumber *videoProfile;
@property(nonatomic, strong, nullable) NSNumber *frameRate;
@property(nonatomic, strong, nullable) NSNumber *minFrameRate;
@property(nonatomic, strong, nullable) NSNumber *bitrate;
@property(nonatomic, strong, nullable) NSNumber *minBitrate;
@end

@interface NEFLTSubscribeRemoteVideoStreamRequest : NSObject
+ (instancetype)makeWithUid:(nullable NSNumber *)uid
                 streamType:(nullable NSNumber *)streamType
                  subscribe:(nullable NSNumber *)subscribe;
@property(nonatomic, strong, nullable) NSNumber *uid;
@property(nonatomic, strong, nullable) NSNumber *streamType;
@property(nonatomic, strong, nullable) NSNumber *subscribe;
@end

@interface NEFLTSubscribeRemoteSubStreamVideoRequest : NSObject
+ (instancetype)makeWithUid:(nullable NSNumber *)uid subscribe:(nullable NSNumber *)subscribe;
@property(nonatomic, strong, nullable) NSNumber *uid;
@property(nonatomic, strong, nullable) NSNumber *subscribe;
@end

@interface NEFLTEnableAudioVolumeIndicationRequest : NSObject
+ (instancetype)makeWithEnable:(nullable NSNumber *)enable
                      interval:(nullable NSNumber *)interval
                           vad:(nullable NSNumber *)vad;
@property(nonatomic, strong, nullable) NSNumber *enable;
@property(nonatomic, strong, nullable) NSNumber *interval;
@property(nonatomic, strong, nullable) NSNumber *vad;
@end

@interface NEFLTSubscribeRemoteSubStreamAudioRequest : NSObject
+ (instancetype)makeWithSubscribe:(nullable NSNumber *)subscribe uid:(nullable NSNumber *)uid;
@property(nonatomic, strong, nullable) NSNumber *subscribe;
@property(nonatomic, strong, nullable) NSNumber *uid;
@end

@interface NEFLTSetAudioSubscribeOnlyByRequest : NSObject
+ (instancetype)makeWithUidArray:(nullable NSArray<NSNumber *> *)uidArray;
@property(nonatomic, strong, nullable) NSArray<NSNumber *> *uidArray;
@end

@interface NEFLTStartAudioMixingRequest : NSObject
+ (instancetype)makeWithPath:(nullable NSString *)path
                   loopCount:(nullable NSNumber *)loopCount
                 sendEnabled:(nullable NSNumber *)sendEnabled
                  sendVolume:(nullable NSNumber *)sendVolume
             playbackEnabled:(nullable NSNumber *)playbackEnabled
              playbackVolume:(nullable NSNumber *)playbackVolume
              startTimeStamp:(nullable NSNumber *)startTimeStamp
           sendWithAudioType:(nullable NSNumber *)sendWithAudioType
            progressInterval:(nullable NSNumber *)progressInterval;
@property(nonatomic, copy, nullable) NSString *path;
@property(nonatomic, strong, nullable) NSNumber *loopCount;
@property(nonatomic, strong, nullable) NSNumber *sendEnabled;
@property(nonatomic, strong, nullable) NSNumber *sendVolume;
@property(nonatomic, strong, nullable) NSNumber *playbackEnabled;
@property(nonatomic, strong, nullable) NSNumber *playbackVolume;
@property(nonatomic, strong, nullable) NSNumber *startTimeStamp;
@property(nonatomic, strong, nullable) NSNumber *sendWithAudioType;
@property(nonatomic, strong, nullable) NSNumber *progressInterval;
@end

@interface NEFLTPlayEffectRequest : NSObject
+ (instancetype)makeWithEffectId:(nullable NSNumber *)effectId
                            path:(nullable NSString *)path
                       loopCount:(nullable NSNumber *)loopCount
                     sendEnabled:(nullable NSNumber *)sendEnabled
                      sendVolume:(nullable NSNumber *)sendVolume
                 playbackEnabled:(nullable NSNumber *)playbackEnabled
                  playbackVolume:(nullable NSNumber *)playbackVolume
                  startTimestamp:(nullable NSNumber *)startTimestamp
               sendWithAudioType:(nullable NSNumber *)sendWithAudioType
                progressInterval:(nullable NSNumber *)progressInterval;
@property(nonatomic, strong, nullable) NSNumber *effectId;
@property(nonatomic, copy, nullable) NSString *path;
@property(nonatomic, strong, nullable) NSNumber *loopCount;
@property(nonatomic, strong, nullable) NSNumber *sendEnabled;
@property(nonatomic, strong, nullable) NSNumber *sendVolume;
@property(nonatomic, strong, nullable) NSNumber *playbackEnabled;
@property(nonatomic, strong, nullable) NSNumber *playbackVolume;
@property(nonatomic, strong, nullable) NSNumber *startTimestamp;
@property(nonatomic, strong, nullable) NSNumber *sendWithAudioType;
@property(nonatomic, strong, nullable) NSNumber *progressInterval;
@end

@interface NEFLTSetCameraPositionRequest : NSObject
+ (instancetype)makeWithX:(nullable NSNumber *)x y:(nullable NSNumber *)y;
@property(nonatomic, strong, nullable) NSNumber *x;
@property(nonatomic, strong, nullable) NSNumber *y;
@end

@interface NEFLTAddOrUpdateLiveStreamTaskRequest : NSObject
+ (instancetype)makeWithSerial:(nullable NSNumber *)serial
                        taskId:(nullable NSString *)taskId
                           url:(nullable NSString *)url
           serverRecordEnabled:(nullable NSNumber *)serverRecordEnabled
                      liveMode:(nullable NSNumber *)liveMode
                   layoutWidth:(nullable NSNumber *)layoutWidth
                  layoutHeight:(nullable NSNumber *)layoutHeight
         layoutBackgroundColor:(nullable NSNumber *)layoutBackgroundColor
                layoutImageUrl:(nullable NSString *)layoutImageUrl
                  layoutImageX:(nullable NSNumber *)layoutImageX
                  layoutImageY:(nullable NSNumber *)layoutImageY
              layoutImageWidth:(nullable NSNumber *)layoutImageWidth
             layoutImageHeight:(nullable NSNumber *)layoutImageHeight
     layoutUserTranscodingList:(nullable NSArray *)layoutUserTranscodingList;
@property(nonatomic, strong, nullable) NSNumber *serial;
@property(nonatomic, copy, nullable) NSString *taskId;
@property(nonatomic, copy, nullable) NSString *url;
@property(nonatomic, strong, nullable) NSNumber *serverRecordEnabled;
@property(nonatomic, strong, nullable) NSNumber *liveMode;
@property(nonatomic, strong, nullable) NSNumber *layoutWidth;
@property(nonatomic, strong, nullable) NSNumber *layoutHeight;
@property(nonatomic, strong, nullable) NSNumber *layoutBackgroundColor;
@property(nonatomic, copy, nullable) NSString *layoutImageUrl;
@property(nonatomic, strong, nullable) NSNumber *layoutImageX;
@property(nonatomic, strong, nullable) NSNumber *layoutImageY;
@property(nonatomic, strong, nullable) NSNumber *layoutImageWidth;
@property(nonatomic, strong, nullable) NSNumber *layoutImageHeight;
@property(nonatomic, strong, nullable) NSArray *layoutUserTranscodingList;
@end

@interface NEFLTDeleteLiveStreamTaskRequest : NSObject
+ (instancetype)makeWithSerial:(nullable NSNumber *)serial taskId:(nullable NSString *)taskId;
@property(nonatomic, strong, nullable) NSNumber *serial;
@property(nonatomic, copy, nullable) NSString *taskId;
@end

@interface NEFLTSendSEIMsgRequest : NSObject
+ (instancetype)makeWithSeiMsg:(nullable NSString *)seiMsg
                    streamType:(nullable NSNumber *)streamType;
@property(nonatomic, copy, nullable) NSString *seiMsg;
@property(nonatomic, strong, nullable) NSNumber *streamType;
@end

@interface NEFLTSetLocalVoiceEqualizationRequest : NSObject
+ (instancetype)makeWithBandFrequency:(nullable NSNumber *)bandFrequency
                             bandGain:(nullable NSNumber *)bandGain;
@property(nonatomic, strong, nullable) NSNumber *bandFrequency;
@property(nonatomic, strong, nullable) NSNumber *bandGain;
@end

@interface NEFLTSwitchChannelRequest : NSObject
+ (instancetype)makeWithToken:(nullable NSString *)token
                  channelName:(nullable NSString *)channelName
               channelOptions:(nullable NEFLTJoinChannelOptions *)channelOptions;
@property(nonatomic, copy, nullable) NSString *token;
@property(nonatomic, copy, nullable) NSString *channelName;
@property(nonatomic, strong, nullable) NEFLTJoinChannelOptions *channelOptions;
@end

@interface NEFLTStartAudioRecordingRequest : NSObject
+ (instancetype)makeWithFilePath:(nullable NSString *)filePath
                      sampleRate:(nullable NSNumber *)sampleRate
                         quality:(nullable NSNumber *)quality;
@property(nonatomic, copy, nullable) NSString *filePath;
@property(nonatomic, strong, nullable) NSNumber *sampleRate;
@property(nonatomic, strong, nullable) NSNumber *quality;
@end

@interface NEFLTAudioRecordingConfigurationRequest : NSObject
+ (instancetype)makeWithFilePath:(nullable NSString *)filePath
                      sampleRate:(nullable NSNumber *)sampleRate
                         quality:(nullable NSNumber *)quality
                        position:(nullable NSNumber *)position
                       cycleTime:(nullable NSNumber *)cycleTime;
@property(nonatomic, copy, nullable) NSString *filePath;
@property(nonatomic, strong, nullable) NSNumber *sampleRate;
@property(nonatomic, strong, nullable) NSNumber *quality;
@property(nonatomic, strong, nullable) NSNumber *position;
@property(nonatomic, strong, nullable) NSNumber *cycleTime;
@end

@interface NEFLTSetLocalMediaPriorityRequest : NSObject
+ (instancetype)makeWithPriority:(nullable NSNumber *)priority
                    isPreemptive:(nullable NSNumber *)isPreemptive;
@property(nonatomic, strong, nullable) NSNumber *priority;
@property(nonatomic, strong, nullable) NSNumber *isPreemptive;
@end

@interface NEFLTStartOrUpdateChannelMediaRelayRequest : NSObject
+ (instancetype)makeWithSourceMediaInfo:(nullable NSDictionary<id, id> *)sourceMediaInfo
                          destMediaInfo:
                              (nullable NSDictionary<id, NSDictionary<id, id> *> *)destMediaInfo;
@property(nonatomic, strong, nullable) NSDictionary<id, id> *sourceMediaInfo;
@property(nonatomic, strong, nullable) NSDictionary<id, NSDictionary<id, id> *> *destMediaInfo;
@end

@interface NEFLTAdjustUserPlaybackSignalVolumeRequest : NSObject
+ (instancetype)makeWithUid:(nullable NSNumber *)uid volume:(nullable NSNumber *)volume;
@property(nonatomic, strong, nullable) NSNumber *uid;
@property(nonatomic, strong, nullable) NSNumber *volume;
@end

@interface NEFLTEnableEncryptionRequest : NSObject
+ (instancetype)makeWithKey:(nullable NSString *)key
                       mode:(nullable NSNumber *)mode
                     enable:(nullable NSNumber *)enable;
@property(nonatomic, copy, nullable) NSString *key;
@property(nonatomic, strong, nullable) NSNumber *mode;
@property(nonatomic, strong, nullable) NSNumber *enable;
@end

@interface NEFLTSetLocalVoiceReverbParamRequest : NSObject
+ (instancetype)makeWithWetGain:(nullable NSNumber *)wetGain
                        dryGain:(nullable NSNumber *)dryGain
                        damping:(nullable NSNumber *)damping
                       roomSize:(nullable NSNumber *)roomSize
                      decayTime:(nullable NSNumber *)decayTime
                       preDelay:(nullable NSNumber *)preDelay;
@property(nonatomic, strong, nullable) NSNumber *wetGain;
@property(nonatomic, strong, nullable) NSNumber *dryGain;
@property(nonatomic, strong, nullable) NSNumber *damping;
@property(nonatomic, strong, nullable) NSNumber *roomSize;
@property(nonatomic, strong, nullable) NSNumber *decayTime;
@property(nonatomic, strong, nullable) NSNumber *preDelay;
@end

@interface NEFLTReportCustomEventRequest : NSObject
+ (instancetype)makeWithEventName:(nullable NSString *)eventName
                   customIdentify:(nullable NSString *)customIdentify
                            param:(nullable NSDictionary<NSString *, id> *)param;
@property(nonatomic, copy, nullable) NSString *eventName;
@property(nonatomic, copy, nullable) NSString *customIdentify;
@property(nonatomic, strong, nullable) NSDictionary<NSString *, id> *param;
@end

@interface NEFLTStartLastmileProbeTestRequest : NSObject
+ (instancetype)makeWithProbeUplink:(nullable NSNumber *)probeUplink
                      probeDownlink:(nullable NSNumber *)probeDownlink
              expectedUplinkBitrate:(nullable NSNumber *)expectedUplinkBitrate
            expectedDownlinkBitrate:(nullable NSNumber *)expectedDownlinkBitrate;
@property(nonatomic, strong, nullable) NSNumber *probeUplink;
@property(nonatomic, strong, nullable) NSNumber *probeDownlink;
@property(nonatomic, strong, nullable) NSNumber *expectedUplinkBitrate;
@property(nonatomic, strong, nullable) NSNumber *expectedDownlinkBitrate;
@end

/// 顶点坐标
@interface NEFLTCGPoint : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithX:(NSNumber *)x y:(NSNumber *)y;
/// x 的 取值范围是 &#91; 0-1 &#93;
@property(nonatomic, strong) NSNumber *x;
/// y 的 取值范围是 &#91; 0-1 &#93;
@property(nonatomic, strong) NSNumber *y;
@end

@interface NEFLTSetVideoCorrectionConfigRequest : NSObject
+ (instancetype)makeWithTopLeft:(nullable NEFLTCGPoint *)topLeft
                       topRight:(nullable NEFLTCGPoint *)topRight
                     bottomLeft:(nullable NEFLTCGPoint *)bottomLeft
                    bottomRight:(nullable NEFLTCGPoint *)bottomRight
                    canvasWidth:(nullable NSNumber *)canvasWidth
                   canvasHeight:(nullable NSNumber *)canvasHeight
                   enableMirror:(nullable NSNumber *)enableMirror;
@property(nonatomic, strong, nullable) NEFLTCGPoint *topLeft;
@property(nonatomic, strong, nullable) NEFLTCGPoint *topRight;
@property(nonatomic, strong, nullable) NEFLTCGPoint *bottomLeft;
@property(nonatomic, strong, nullable) NEFLTCGPoint *bottomRight;
@property(nonatomic, strong, nullable) NSNumber *canvasWidth;
@property(nonatomic, strong, nullable) NSNumber *canvasHeight;
@property(nonatomic, strong, nullable) NSNumber *enableMirror;
@end

@interface NEFLTEnableVirtualBackgroundRequest : NSObject
+ (instancetype)makeWithEnabled:(nullable NSNumber *)enabled
           backgroundSourceType:(nullable NSNumber *)backgroundSourceType
                          color:(nullable NSNumber *)color
                         source:(nullable NSString *)source
                    blur_degree:(nullable NSNumber *)blur_degree;
@property(nonatomic, strong, nullable) NSNumber *enabled;
@property(nonatomic, strong, nullable) NSNumber *backgroundSourceType;
@property(nonatomic, strong, nullable) NSNumber *color;
@property(nonatomic, copy, nullable) NSString *source;
@property(nonatomic, strong, nullable) NSNumber *blur_degree;
@end

@interface NEFLTSetRemoteHighPriorityAudioStreamRequest : NSObject
+ (instancetype)makeWithEnabled:(nullable NSNumber *)enabled
                            uid:(nullable NSNumber *)uid
                     streamType:(nullable NSNumber *)streamType;
@property(nonatomic, strong, nullable) NSNumber *enabled;
@property(nonatomic, strong, nullable) NSNumber *uid;
@property(nonatomic, strong, nullable) NSNumber *streamType;
@end

@interface NEFLTVideoWatermarkImageConfig : NSObject
+ (instancetype)makeWithWmAlpha:(nullable NSNumber *)wmAlpha
                        wmWidth:(nullable NSNumber *)wmWidth
                       wmHeight:(nullable NSNumber *)wmHeight
                        offsetX:(nullable NSNumber *)offsetX
                        offsetY:(nullable NSNumber *)offsetY
                     imagePaths:(nullable NSArray<NSString *> *)imagePaths
                            fps:(nullable NSNumber *)fps
                           loop:(nullable NSNumber *)loop;
@property(nonatomic, strong, nullable) NSNumber *wmAlpha;
@property(nonatomic, strong, nullable) NSNumber *wmWidth;
@property(nonatomic, strong, nullable) NSNumber *wmHeight;
@property(nonatomic, strong, nullable) NSNumber *offsetX;
@property(nonatomic, strong, nullable) NSNumber *offsetY;
@property(nonatomic, strong, nullable) NSArray<NSString *> *imagePaths;
@property(nonatomic, strong, nullable) NSNumber *fps;
@property(nonatomic, strong, nullable) NSNumber *loop;
@end

@interface NEFLTVideoWatermarkTextConfig : NSObject
+ (instancetype)makeWithWmAlpha:(nullable NSNumber *)wmAlpha
                        wmWidth:(nullable NSNumber *)wmWidth
                       wmHeight:(nullable NSNumber *)wmHeight
                        offsetX:(nullable NSNumber *)offsetX
                        offsetY:(nullable NSNumber *)offsetY
                        wmColor:(nullable NSNumber *)wmColor
                       fontSize:(nullable NSNumber *)fontSize
                      fontColor:(nullable NSNumber *)fontColor
                 fontNameOrPath:(nullable NSString *)fontNameOrPath
                        content:(nullable NSString *)content;
@property(nonatomic, strong, nullable) NSNumber *wmAlpha;
@property(nonatomic, strong, nullable) NSNumber *wmWidth;
@property(nonatomic, strong, nullable) NSNumber *wmHeight;
@property(nonatomic, strong, nullable) NSNumber *offsetX;
@property(nonatomic, strong, nullable) NSNumber *offsetY;
@property(nonatomic, strong, nullable) NSNumber *wmColor;
@property(nonatomic, strong, nullable) NSNumber *fontSize;
@property(nonatomic, strong, nullable) NSNumber *fontColor;
@property(nonatomic, copy, nullable) NSString *fontNameOrPath;
@property(nonatomic, copy, nullable) NSString *content;
@end

@interface NEFLTVideoWatermarkTimestampConfig : NSObject
+ (instancetype)makeWithWmAlpha:(nullable NSNumber *)wmAlpha
                        wmWidth:(nullable NSNumber *)wmWidth
                       wmHeight:(nullable NSNumber *)wmHeight
                        offsetX:(nullable NSNumber *)offsetX
                        offsetY:(nullable NSNumber *)offsetY
                        wmColor:(nullable NSNumber *)wmColor
                       fontSize:(nullable NSNumber *)fontSize
                      fontColor:(nullable NSNumber *)fontColor
                 fontNameOrPath:(nullable NSString *)fontNameOrPath;
@property(nonatomic, strong, nullable) NSNumber *wmAlpha;
@property(nonatomic, strong, nullable) NSNumber *wmWidth;
@property(nonatomic, strong, nullable) NSNumber *wmHeight;
@property(nonatomic, strong, nullable) NSNumber *offsetX;
@property(nonatomic, strong, nullable) NSNumber *offsetY;
@property(nonatomic, strong, nullable) NSNumber *wmColor;
@property(nonatomic, strong, nullable) NSNumber *fontSize;
@property(nonatomic, strong, nullable) NSNumber *fontColor;
@property(nonatomic, copy, nullable) NSString *fontNameOrPath;
@end

/// 视频水印设置，目前支持三种类型的水印，但只能其中选择一种水印生效
@interface NEFLTVideoWatermarkConfig : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithWatermarkType:(NEFLTNERtcVideoWatermarkType)WatermarkType
                       imageWatermark:(nullable NEFLTVideoWatermarkImageConfig *)imageWatermark
                        textWatermark:(nullable NEFLTVideoWatermarkTextConfig *)textWatermark
                   timestampWatermark:
                       (nullable NEFLTVideoWatermarkTimestampConfig *)timestampWatermark;
@property(nonatomic, assign) NEFLTNERtcVideoWatermarkType WatermarkType;
@property(nonatomic, strong, nullable) NEFLTVideoWatermarkImageConfig *imageWatermark;
@property(nonatomic, strong, nullable) NEFLTVideoWatermarkTextConfig *textWatermark;
@property(nonatomic, strong, nullable) NEFLTVideoWatermarkTimestampConfig *timestampWatermark;
@end

@interface NEFLTSetLocalVideoWatermarkConfigsRequest : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithType:(NSNumber *)type config:(nullable NEFLTVideoWatermarkConfig *)config;
@property(nonatomic, strong) NSNumber *type;
@property(nonatomic, strong, nullable) NEFLTVideoWatermarkConfig *config;
@end

/// NERtc 版本信息
@interface NEFLTNERtcVersion : NSObject
+ (instancetype)makeWithVersionName:(nullable NSString *)versionName
                        versionCode:(nullable NSNumber *)versionCode
                          buildType:(nullable NSString *)buildType
                          buildDate:(nullable NSString *)buildDate
                      buildRevision:(nullable NSString *)buildRevision
                          buildHost:(nullable NSString *)buildHost
                          serverEnv:(nullable NSString *)serverEnv
                        buildBranch:(nullable NSString *)buildBranch
                     engineRevision:(nullable NSString *)engineRevision;
@property(nonatomic, copy, nullable) NSString *versionName;
@property(nonatomic, strong, nullable) NSNumber *versionCode;
@property(nonatomic, copy, nullable) NSString *buildType;
@property(nonatomic, copy, nullable) NSString *buildDate;
@property(nonatomic, copy, nullable) NSString *buildRevision;
@property(nonatomic, copy, nullable) NSString *buildHost;
@property(nonatomic, copy, nullable) NSString *serverEnv;
@property(nonatomic, copy, nullable) NSString *buildBranch;
@property(nonatomic, copy, nullable) NSString *engineRevision;
@end

@interface NEFLTVideoFrame : NSObject
+ (instancetype)makeWithWidth:(nullable NSNumber *)width
                       height:(nullable NSNumber *)height
                     rotation:(nullable NSNumber *)rotation
                       format:(nullable NSNumber *)format
                    timeStamp:(nullable NSNumber *)timeStamp
                         data:(nullable FlutterStandardTypedData *)data
                      strideY:(nullable NSNumber *)strideY
                      strideU:(nullable NSNumber *)strideU
                      strideV:(nullable NSNumber *)strideV
                    textureId:(nullable NSNumber *)textureId
              transformMatrix:(nullable NSArray<NSNumber *> *)transformMatrix;
@property(nonatomic, strong, nullable) NSNumber *width;
@property(nonatomic, strong, nullable) NSNumber *height;
@property(nonatomic, strong, nullable) NSNumber *rotation;
@property(nonatomic, strong, nullable) NSNumber *format;
@property(nonatomic, strong, nullable) NSNumber *timeStamp;
@property(nonatomic, strong, nullable) FlutterStandardTypedData *data;
@property(nonatomic, strong, nullable) NSNumber *strideY;
@property(nonatomic, strong, nullable) NSNumber *strideU;
@property(nonatomic, strong, nullable) NSNumber *strideV;
@property(nonatomic, strong, nullable) NSNumber *textureId;
@property(nonatomic, strong, nullable) NSArray<NSNumber *> *transformMatrix;
@end

/// The codec used by NEFLTNERtcChannelEventSink.
NSObject<FlutterMessageCodec> *NEFLTNERtcChannelEventSinkGetCodec(void);

@interface NEFLTNERtcChannelEventSink : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)onJoinChannelResult:(NSNumber *)result
                  channelId:(NSNumber *)channelId
                    elapsed:(NSNumber *)elapsed
                        uid:(NSNumber *)uid
                 completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onLeaveChannelResult:(NSNumber *)result
                  completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserJoinedEvent:(NEFLTUserJoinedEvent *)event
               completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserLeaveEvent:(NEFLTUserLeaveEvent *)event
              completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserAudioStartUid:(NSNumber *)uid
                 completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserSubStreamAudioStartUid:(NSNumber *)uid
                          completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserAudioStopUid:(NSNumber *)uid completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserSubStreamAudioStopUid:(NSNumber *)uid
                         completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserVideoStartUid:(NSNumber *)uid
                 maxProfile:(NSNumber *)maxProfile
                 completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserVideoStopUid:(NSNumber *)uid completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onDisconnectReason:(NSNumber *)reason
                completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserAudioMuteUid:(NSNumber *)uid
                     muted:(NSNumber *)muted
                completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserVideoMuteEvent:(NEFLTUserVideoMuteEvent *)event
                  completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserSubStreamAudioMuteUid:(NSNumber *)uid
                              muted:(NSNumber *)muted
                         completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onFirstAudioDataReceivedUid:(NSNumber *)uid
                         completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onFirstVideoDataReceivedEvent:(NEFLTFirstVideoDataReceivedEvent *)event
                           completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onFirstAudioFrameDecodedUid:(NSNumber *)uid
                         completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onFirstVideoFrameDecodedEvent:(NEFLTFirstVideoFrameDecodedEvent *)event
                           completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onVirtualBackgroundSourceEnabledEvent:(NEFLTVirtualBackgroundSourceEnabledEvent *)event
                                   completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onConnectionTypeChangedNewConnectionType:(NSNumber *)newConnectionType
                                      completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onReconnectingStartWithCompletion:(void (^)(FlutterError *_Nullable))completion;
- (void)onReJoinChannelResult:(NSNumber *)result
                    channelId:(NSNumber *)channelId
                   completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onConnectionStateChangedState:(NSNumber *)state
                               reason:(NSNumber *)reason
                           completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onLocalAudioVolumeIndicationVolume:(NSNumber *)volume
                                   vadFlag:(NSNumber *)vadFlag
                                completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onRemoteAudioVolumeIndicationEvent:(NEFLTRemoteAudioVolumeIndicationEvent *)event
                                completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onLiveStreamStateTaskId:(NSString *)taskId
                        pushUrl:(NSString *)pushUrl
                      liveState:(NSNumber *)liveState
                     completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onClientRoleChangeOldRole:(NSNumber *)oldRole
                          newRole:(NSNumber *)newRole
                       completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onErrorCode:(NSNumber *)code completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onWarningCode:(NSNumber *)code completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserSubStreamVideoStartUid:(NSNumber *)uid
                          maxProfile:(NSNumber *)maxProfile
                          completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onUserSubStreamVideoStopUid:(NSNumber *)uid
                         completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onAudioHasHowlingWithCompletion:(void (^)(FlutterError *_Nullable))completion;
- (void)onRecvSEIMsgUserID:(NSNumber *)userID
                    seiMsg:(NSString *)seiMsg
                completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onAudioRecordingCode:(NSNumber *)code
                    filePath:(NSString *)filePath
                  completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onMediaRightChangeIsAudioBannedByServer:(NSNumber *)isAudioBannedByServer
                          isVideoBannedByServer:(NSNumber *)isVideoBannedByServer
                                     completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onMediaRelayStatesChangeState:(NSNumber *)state
                          channelName:(NSString *)channelName
                           completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onMediaRelayReceiveEventEvent:(NSNumber *)event
                                 code:(NSNumber *)code
                          channelName:(NSString *)channelName
                           completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onLocalPublishFallbackToAudioOnlyIsFallback:(NSNumber *)isFallback
                                         streamType:(NSNumber *)streamType
                                         completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onRemoteSubscribeFallbackToAudioOnlyUid:(NSNumber *)uid
                                     isFallback:(NSNumber *)isFallback
                                     streamType:(NSNumber *)streamType
                                     completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onLocalVideoWatermarkStateVideoStreamType:(NSNumber *)videoStreamType
                                            state:(NSNumber *)state
                                       completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onLastmileQualityQuality:(NSNumber *)quality
                      completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onLastmileProbeResultResult:(NEFLTNERtcLastmileProbeResult *)result
                         completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onTakeSnapshotResultCode:(NSNumber *)code
                            path:(NSString *)path
                      completion:(void (^)(FlutterError *_Nullable))completion;
@end

/// The codec used by NEFLTEngineApi.
NSObject<FlutterMessageCodec> *NEFLTEngineApiGetCodec(void);

@protocol NEFLTEngineApi
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)createRequest:(NEFLTCreateEngineRequest *)request
                               error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NEFLTNERtcVersion *)versionWithError:(FlutterError *_Nullable *_Nonnull)error;
- (nullable NSArray<NSString *> *)checkPermissionWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setParametersParams:(NSDictionary<NSString *, id> *)params
                                     error:(FlutterError *_Nullable *_Nonnull)error;
- (void)releaseWithCompletion:(void (^)(NSNumber *_Nullable, FlutterError *_Nullable))completion;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setStatsEventCallbackWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)clearStatsEventCallbackWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setChannelProfileChannelProfile:(NSNumber *)channelProfile
                                                 error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)joinChannelRequest:(NEFLTJoinChannelRequest *)request
                                    error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)leaveChannelWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)updatePermissionKeyKey:(NSString *)key
                                        error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableLocalAudioEnable:(NSNumber *)enable
                                        error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)subscribeRemoteAudioRequest:(NEFLTSubscribeRemoteAudioRequest *)request
                                             error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)subscribeAllRemoteAudioSubscribe:(NSNumber *)subscribe
                                                  error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setAudioProfileRequest:(NEFLTSetAudioProfileRequest *)request
                                        error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableDualStreamModeEnable:(NSNumber *)enable
                                            error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setLocalVideoConfigRequest:(NEFLTSetLocalVideoConfigRequest *)request
                                            error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setCameraCaptureConfigRequest:(NEFLTSetCameraCaptureConfigRequest *)request
                                               error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)startVideoPreviewRequest:(NEFLTStartorStopVideoPreviewRequest *)request
                                          error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)stopVideoPreviewRequest:(NEFLTStartorStopVideoPreviewRequest *)request
                                         error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableLocalVideoRequest:(NEFLTEnableLocalVideoRequest *)request
                                         error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableLocalSubStreamAudioEnable:(NSNumber *)enable
                                                 error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)
    subscribeRemoteSubStreamAudioRequest:(NEFLTSubscribeRemoteSubStreamAudioRequest *)request
                                   error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)muteLocalSubStreamAudioMuted:(NSNumber *)muted
                                              error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setAudioSubscribeOnlyByRequest:(NEFLTSetAudioSubscribeOnlyByRequest *)request
                                                error:(FlutterError *_Nullable *_Nonnull)error;
- (void)startScreenCaptureRequest:(NEFLTStartScreenCaptureRequest *)request
                       completion:
                           (void (^)(NSNumber *_Nullable, FlutterError *_Nullable))completion;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)stopScreenCaptureWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableLoopbackRecordingEnable:(NSNumber *)enable
                                               error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)subscribeRemoteVideoStreamRequest:
                           (NEFLTSubscribeRemoteVideoStreamRequest *)request
                                                   error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)
    subscribeRemoteSubStreamVideoRequest:(NEFLTSubscribeRemoteSubStreamVideoRequest *)request
                                   error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)muteLocalAudioStreamMute:(NSNumber *)mute
                                          error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)muteLocalVideoStreamMute:(NSNumber *)mute
                                     streamType:(NSNumber *)streamType
                                          error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)startAudioDumpWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)startAudioDumpWithTypeDumpType:(NSNumber *)dumpType
                                                error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)stopAudioDumpWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableAudioVolumeIndicationRequest:
                           (NEFLTEnableAudioVolumeIndicationRequest *)request
                                                    error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)adjustRecordingSignalVolumeVolume:(NSNumber *)volume
                                                   error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)adjustPlaybackSignalVolumeVolume:(NSNumber *)volume
                                                  error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)adjustLoopBackRecordingSignalVolumeVolume:(NSNumber *)volume
                                                           error:(FlutterError *_Nullable *_Nonnull)
                                                                     error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)addLiveStreamTaskRequest:(NEFLTAddOrUpdateLiveStreamTaskRequest *)request
                                          error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)updateLiveStreamTaskRequest:(NEFLTAddOrUpdateLiveStreamTaskRequest *)request
                                             error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)removeLiveStreamTaskRequest:(NEFLTDeleteLiveStreamTaskRequest *)request
                                             error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setClientRoleRole:(NSNumber *)role
                                   error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getConnectionStateWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)uploadSdkInfoWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)sendSEIMsgRequest:(NEFLTSendSEIMsgRequest *)request
                                   error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setLocalVoiceReverbParamRequest:
                           (NEFLTSetLocalVoiceReverbParamRequest *)request
                                                 error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setAudioEffectPresetPreset:(NSNumber *)preset
                                            error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setVoiceBeautifierPresetPreset:(NSNumber *)preset
                                                error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setLocalVoicePitchPitch:(NSNumber *)pitch
                                         error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setLocalVoiceEqualizationRequest:
                           (NEFLTSetLocalVoiceEqualizationRequest *)request
                                                  error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)switchChannelRequest:(NEFLTSwitchChannelRequest *)request
                                      error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)startAudioRecordingRequest:(NEFLTStartAudioRecordingRequest *)request
                                            error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)
    startAudioRecordingWithConfigRequest:(NEFLTAudioRecordingConfigurationRequest *)request
                                   error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)stopAudioRecordingWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setLocalMediaPriorityRequest:(NEFLTSetLocalMediaPriorityRequest *)request
                                              error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableMediaPubMediaType:(NSNumber *)mediaType
                                        enable:(NSNumber *)enable
                                         error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)startChannelMediaRelayRequest:
                           (NEFLTStartOrUpdateChannelMediaRelayRequest *)request
                                               error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)updateChannelMediaRelayRequest:
                           (NEFLTStartOrUpdateChannelMediaRelayRequest *)request
                                                error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)stopChannelMediaRelayWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)
    adjustUserPlaybackSignalVolumeRequest:(NEFLTAdjustUserPlaybackSignalVolumeRequest *)request
                                    error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setLocalPublishFallbackOptionOption:(NSNumber *)option
                                                     error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setRemoteSubscribeFallbackOptionOption:(NSNumber *)option
                                                        error:(FlutterError *_Nullable *_Nonnull)
                                                                  error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableSuperResolutionEnable:(NSNumber *)enable
                                             error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableEncryptionRequest:(NEFLTEnableEncryptionRequest *)request
                                         error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setAudioSessionOperationRestrictionOption:(NSNumber *)option
                                                           error:(FlutterError *_Nullable *_Nonnull)
                                                                     error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableVideoCorrectionEnable:(NSNumber *)enable
                                             error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)reportCustomEventRequest:(NEFLTReportCustomEventRequest *)request
                                          error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getEffectDurationEffectId:(NSNumber *)effectId
                                           error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)startLastmileProbeTestRequest:(NEFLTStartLastmileProbeTestRequest *)request
                                               error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)stopLastmileProbeTestWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setVideoCorrectionConfigRequest:
                           (NEFLTSetVideoCorrectionConfigRequest *)request
                                                 error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableVirtualBackgroundRequest:(NEFLTEnableVirtualBackgroundRequest *)request
                                                error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)
    setRemoteHighPriorityAudioStreamRequest:(NEFLTSetRemoteHighPriorityAudioStreamRequest *)request
                                      error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setCloudProxyProxyType:(NSNumber *)proxyType
                                        error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)startBeautyWithError:(FlutterError *_Nullable *_Nonnull)error;
- (void)stopBeautyWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableBeautyEnabled:(NSNumber *)enabled
                                     error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setBeautyEffectLevel:(NSNumber *)level
                                 beautyType:(NSNumber *)beautyType
                                      error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)addBeautyFilterPath:(NSString *)path
                                      name:(NSString *)name
                                     error:(FlutterError *_Nullable *_Nonnull)error;
- (void)removeBeautyFilterWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setBeautyFilterLevelLevel:(NSNumber *)level
                                           error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)
    setLocalVideoWatermarkConfigsRequest:(NEFLTSetLocalVideoWatermarkConfigsRequest *)request
                                   error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setStreamAlignmentPropertyEnable:(NSNumber *)enable
                                                  error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getNtpTimeOffsetWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)takeLocalSnapshotStreamType:(NSNumber *)streamType
                                              path:(NSString *)path
                                             error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)takeRemoteSnapshotUid:(NSNumber *)uid
                                  streamType:(NSNumber *)streamType
                                        path:(NSString *)path
                                       error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setExternalVideoSourceStreamType:(NSNumber *)streamType
                                                 enable:(NSNumber *)enable
                                                  error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)pushExternalVideoFrameStreamType:(NSNumber *)streamType
                                                  frame:(NEFLTVideoFrame *)frame
                                                  error:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void NEFLTEngineApiSetup(id<FlutterBinaryMessenger> binaryMessenger,
                                NSObject<NEFLTEngineApi> *_Nullable api);

/// The codec used by NEFLTVideoRendererApi.
NSObject<FlutterMessageCodec> *NEFLTVideoRendererApiGetCodec(void);

@protocol NEFLTVideoRendererApi
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)createVideoRendererWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setMirrorTextureId:(NSNumber *)textureId
                                   mirror:(NSNumber *)mirror
                                    error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setupLocalVideoRendererTextureId:(NSNumber *)textureId
                                                  error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setupRemoteVideoRendererUid:(NSNumber *)uid
                                         textureId:(NSNumber *)textureId
                                             error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setupLocalSubStreamVideoRendererTextureId:(NSNumber *)textureId
                                                           error:(FlutterError *_Nullable *_Nonnull)
                                                                     error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setupRemoteSubStreamVideoRendererUid:(NSNumber *)uid
                                                  textureId:(NSNumber *)textureId
                                                      error:
                                                          (FlutterError *_Nullable *_Nonnull)error;
- (void)disposeVideoRendererTextureId:(NSNumber *)textureId
                                error:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void NEFLTVideoRendererApiSetup(id<FlutterBinaryMessenger> binaryMessenger,
                                       NSObject<NEFLTVideoRendererApi> *_Nullable api);

/// The codec used by NEFLTNERtcDeviceEventSink.
NSObject<FlutterMessageCodec> *NEFLTNERtcDeviceEventSinkGetCodec(void);

@interface NEFLTNERtcDeviceEventSink : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)onAudioDeviceChangedSelected:(NSNumber *)selected
                          completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onAudioDeviceStateChangeDeviceType:(NSNumber *)deviceType
                               deviceState:(NSNumber *)deviceState
                                completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onVideoDeviceStateChangeDeviceType:(NSNumber *)deviceType
                               deviceState:(NSNumber *)deviceState
                                completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onCameraFocusChangedFocusPoint:(NEFLTCGPoint *)focusPoint
                            completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onCameraExposureChangedExposurePoint:(NEFLTCGPoint *)exposurePoint
                                  completion:(void (^)(FlutterError *_Nullable))completion;
@end

/// The codec used by NEFLTDeviceManagerApi.
NSObject<FlutterMessageCodec> *NEFLTDeviceManagerApiGetCodec(void);

@protocol NEFLTDeviceManagerApi
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)isSpeakerphoneOnWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)isCameraZoomSupportedWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)isCameraTorchSupportedWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)isCameraFocusSupportedWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)isCameraExposurePositionSupportedWithError:
    (FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setSpeakerphoneOnEnable:(NSNumber *)enable
                                         error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)switchCameraWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setCameraZoomFactorFactor:(NSNumber *)factor
                                           error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getCameraMaxZoomWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setCameraTorchOnOn:(NSNumber *)on
                                    error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setCameraFocusPositionRequest:(NEFLTSetCameraPositionRequest *)request
                                               error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setCameraExposurePositionRequest:(NEFLTSetCameraPositionRequest *)request
                                                  error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setPlayoutDeviceMuteMute:(NSNumber *)mute
                                          error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)isPlayoutDeviceMuteWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setRecordDeviceMuteMute:(NSNumber *)mute
                                         error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)isRecordDeviceMuteWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)enableEarbackEnabled:(NSNumber *)enabled
                                     volume:(NSNumber *)volume
                                      error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setEarbackVolumeVolume:(NSNumber *)volume
                                        error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setAudioFocusModeFocusMode:(NSNumber *)focusMode
                                            error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getCurrentCameraWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)switchCameraWithPositionPosition:(NSNumber *)position
                                                  error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getCameraCurrentZoomWithError:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void NEFLTDeviceManagerApiSetup(id<FlutterBinaryMessenger> binaryMessenger,
                                       NSObject<NEFLTDeviceManagerApi> *_Nullable api);

/// The codec used by NEFLTAudioMixingApi.
NSObject<FlutterMessageCodec> *NEFLTAudioMixingApiGetCodec(void);

@protocol NEFLTAudioMixingApi
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)startAudioMixingRequest:(NEFLTStartAudioMixingRequest *)request
                                         error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)stopAudioMixingWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)pauseAudioMixingWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)resumeAudioMixingWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setAudioMixingSendVolumeVolume:(NSNumber *)volume
                                                error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getAudioMixingSendVolumeWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setAudioMixingPlaybackVolumeVolume:(NSNumber *)volume
                                                    error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getAudioMixingPlaybackVolumeWithError:
    (FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getAudioMixingDurationWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getAudioMixingCurrentPositionWithError:
    (FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setAudioMixingPositionPosition:(NSNumber *)position
                                                error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setAudioMixingPitchPitch:(NSNumber *)pitch
                                          error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getAudioMixingPitchWithError:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void NEFLTAudioMixingApiSetup(id<FlutterBinaryMessenger> binaryMessenger,
                                     NSObject<NEFLTAudioMixingApi> *_Nullable api);

/// The codec used by NEFLTNERtcAudioMixingEventSink.
NSObject<FlutterMessageCodec> *NEFLTNERtcAudioMixingEventSinkGetCodec(void);

@interface NEFLTNERtcAudioMixingEventSink : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)onAudioMixingStateChangedReason:(NSNumber *)reason
                             completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onAudioMixingTimestampUpdateTimestampMs:(NSNumber *)timestampMs
                                     completion:(void (^)(FlutterError *_Nullable))completion;
@end

/// The codec used by NEFLTAudioEffectApi.
NSObject<FlutterMessageCodec> *NEFLTAudioEffectApiGetCodec(void);

@protocol NEFLTAudioEffectApi
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)playEffectRequest:(NEFLTPlayEffectRequest *)request
                                   error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)stopEffectEffectId:(NSNumber *)effectId
                                    error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)stopAllEffectsWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)pauseEffectEffectId:(NSNumber *)effectId
                                     error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)resumeEffectEffectId:(NSNumber *)effectId
                                      error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)pauseAllEffectsWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)resumeAllEffectsWithError:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setEffectSendVolumeEffectId:(NSNumber *)effectId
                                            volume:(NSNumber *)volume
                                             error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getEffectSendVolumeEffectId:(NSNumber *)effectId
                                             error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setEffectPlaybackVolumeEffectId:(NSNumber *)effectId
                                                volume:(NSNumber *)volume
                                                 error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getEffectPlaybackVolumeEffectId:(NSNumber *)effectId
                                                 error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getEffectDurationEffectId:(NSNumber *)effectId
                                           error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getEffectCurrentPositionEffectId:(NSNumber *)effectId
                                                  error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setEffectPitchEffectId:(NSNumber *)effectId
                                        pitch:(NSNumber *)pitch
                                        error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)getEffectPitchEffectId:(NSNumber *)effectId
                                        error:(FlutterError *_Nullable *_Nonnull)error;
/// @return `nil` only when `error != nil`.
- (nullable NSNumber *)setEffectPositionEffectId:(NSNumber *)effectId
                                        position:(NSNumber *)position
                                           error:(FlutterError *_Nullable *_Nonnull)error;
@end

extern void NEFLTAudioEffectApiSetup(id<FlutterBinaryMessenger> binaryMessenger,
                                     NSObject<NEFLTAudioEffectApi> *_Nullable api);

/// The codec used by NEFLTNERtcAudioEffectEventSink.
NSObject<FlutterMessageCodec> *NEFLTNERtcAudioEffectEventSinkGetCodec(void);

@interface NEFLTNERtcAudioEffectEventSink : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)onAudioEffectFinishedEffectId:(NSNumber *)effectId
                           completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onAudioEffectTimestampUpdateId:(NSNumber *)id
                           timestampMs:(NSNumber *)timestampMs
                            completion:(void (^)(FlutterError *_Nullable))completion;
@end

/// The codec used by NEFLTNERtcStatsEventSink.
NSObject<FlutterMessageCodec> *NEFLTNERtcStatsEventSinkGetCodec(void);

@interface NEFLTNERtcStatsEventSink : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)onRtcStatsArguments:(NSDictionary<id, id> *)arguments
                 completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onLocalAudioStatsArguments:(NSDictionary<id, id> *)arguments
                        completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onRemoteAudioStatsArguments:(NSDictionary<id, id> *)arguments
                         completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onLocalVideoStatsArguments:(NSDictionary<id, id> *)arguments
                        completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onRemoteVideoStatsArguments:(NSDictionary<id, id> *)arguments
                         completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onNetworkQualityArguments:(NSDictionary<id, id> *)arguments
                       completion:(void (^)(FlutterError *_Nullable))completion;
@end

/// The codec used by NEFLTNERtcLiveStreamEventSink.
NSObject<FlutterMessageCodec> *NEFLTNERtcLiveStreamEventSinkGetCodec(void);

@interface NEFLTNERtcLiveStreamEventSink : NSObject
- (instancetype)initWithBinaryMessenger:(id<FlutterBinaryMessenger>)binaryMessenger;
- (void)onUpdateLiveStreamTaskTaskId:(NSString *)taskId
                             errCode:(NSNumber *)errCode
                          completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onAddLiveStreamTaskTaskId:(NSString *)taskId
                          errCode:(NSNumber *)errCode
                       completion:(void (^)(FlutterError *_Nullable))completion;
- (void)onDeleteLiveStreamTaskTaskId:(NSString *)taskId
                             errCode:(NSNumber *)errCode
                          completion:(void (^)(FlutterError *_Nullable))completion;
@end

NS_ASSUME_NONNULL_END
